<template>
    <div class="row justify-center items-center q-py-md">
        <div class="row items-center col-6 font-18 text-black q-mt-xs">
            <q-btn
                class="q-pr-sm q-pl-lg-md q-pl-md-md q-pl-sm-md q-pl-xs-none"
                flat
                no-caps
                @click="selectCurrentPage(1)"
            >
                <q-icon name="arrow_back" color="black" size="25px" />
            </q-btn>
            <div class="label-title-container helvetica-neue-medium">
                {{ $t('preference.createIssue') }}
            </div>
        </div>
        <div class="col-6 q-pr-md-xl font-18 text-black q-mt-xs text-right">
            <q-btn
                no-caps
                text-color="white"
                class="button-save"
                :label="$t('button.save')"
                @click="createIssuesType"
            />
        </div>
    </div>
    <div class="row justify-start items-center q-px-xs-lg q-px-sm-lg">
        <div class="col-md-4 col-12 q-mt-xs items-center q-mr-md">
            <p class="font-14 q-mb-md helvetica-neue-medium">
                {{ $t('preference.issueName') }}
                <span class="text-ff0000 font-10" v-if="!state.issuesName">
                    {{ $t('form.required') }}
                </span>
            </p>
            <q-input
                outlined
                dense
                v-model="state.issuesName"
                bg-color="blue-2"
            ></q-input>
        </div>
        <div class="col-md-4 col-12 q-mt-xs items-center q-mr-md">
            <p class="font-14 q-mb-md helvetica-neue-medium">
                {{ $t('preference.orderNumber') }}
                <span class="text-ff0000 font-10" v-if="!state.orderNo">
                    {{ $t('form.required') }}
                </span>
            </p>
            <q-input
                outlined
                dense
                v-model="state.orderNo"
                bg-color="blue-2"
                type="number"
            ></q-input>
        </div>
    </div>
    <div class="row justify-start q-px-xs-lg q-px-sm-lg q-pt-lg">
        <div class="col-md-4 col-12 items-center q-pt-md-md q-pt-xs-md">
            <p class="font-14 q-mb-md-none q-mb-xs-none helvetica-neue-medium">
                {{ $t('preference.issueFlag') }}
            </p>
            <q-select
                v-model="state.issuesFlag"
                :options="state.issuesFlagOptions"
                option-value="value"
                option-label="text"
                emit-value
                map-options
            ></q-select>
        </div>
        <div
            class="
                col-md-6 col-12
                q-pr-md-xl q-pl-md-md q-pl-xs-none q-pt-md-md q-pt-xs-md
                justify-center
                items-center
            "
        >
            <p class="font-14 q-mb-md helvetica-neue-medium">
                {{ $t('preference.issueTypeColor') }}
                <span
                    class="text-ff0000 font-10"
                    v-if="!state.selectedColor.name"
                >
                    {{ $t('form.required') }}
                </span>
            </p>

            <div class="row helvetica-neue-medium">
                <div class="col-lg-2 col-md-3 col-xs-3 col-sm-3">
                    <div
                        class="
                            color-container
                            bg-666B72
                            items-center
                            row
                            justify-center
                            border-radius-10
                        "
                        :style="{
                            backgroundColor: state.selectedColor?.name
                        }"
                    >
                        <q-img
                            src="~assets/images/check.png"
                            width="20px"
                            height="20px"
                        />
                    </div>
                </div>
                <div class="col-lg-10 col-md-9 col-xs-9 col-sm-9">
                    <div
                        class="
                            q-ml-md q-mb-sm q-pa-md
                            color-container-mini
                            row
                            border-radius-10
                            pointer
                        "
                        :style="{
                            backgroundColor: color.name
                        }"
                        v-for="(color, index) in state.colors"
                        :key="'color-' + index"
                        @click="selectColor(color)"
                    ></div>
                </div>
            </div>
        </div>
    </div>
</template>
<script lang="ts">
import { defineComponent, reactive } from 'vue';
import { useStore } from 'src/store';

export default defineComponent({
    name: 'CreateIssue',
    components: {},
    setup(props, { emit }) {
        let state = reactive({
            issuesName: '' as any,
            orderNo: 0,
            issuesFlagOptions: [
                { text: 'Internal', value: 'true' },
                { text: 'Public', value: 'false' }
            ],
            issuesFlag: '' as any,
            selectedColor: { name: '' } as any,
            colors: [
                {
                    id: 1,
                    name: '#ffcdd2'
                },
                {
                    id: 2,
                    name: '#ff8a80'
                },
                {
                    id: 3,
                    name: '#e040fb'
                },
                {
                    id: 4,
                    name: '#ea80fc'
                },
                {
                    id: 5,
                    name: '#448aff'
                },
                {
                    id: 6,
                    name: '#82b1ff'
                },
                {
                    id: 7,
                    name: '#1de9b6'
                },
                {
                    id: 8,
                    name: '#69f0ae'
                },
                {
                    id: 9,
                    name: '#ffd600'
                },
                {
                    id: 10,
                    name: '#ffff00'
                },
                {
                    id: 11,
                    name: '#9e9e9e'
                },
                {
                    id: 12,
                    name: '#bdbdbd'
                }
            ]
        });
        const store = useStore();
        const selectCurrentPage = (page: any) => {
            emit('update-issuePage', page);
        };

        const createIssuesType = async () => {
            if (store.state.role.permissions.issuesType?.create) {
                if (state.selectedColor?.name === '') {
                    state.selectedColor.name = '#666B72';
                }
                const res = await store.dispatch('issueType/createIssuesType', {
                    name: state.issuesName,
                    orderNo: state.orderNo,
                    isHidden: state.issuesFlag,
                    color: state.selectedColor.name
                });
                if (res.status == 200) {
                    selectCurrentPage(1);
                }
            }
        };

        const selectColor = (color: any) => {
            state.selectedColor.name = color.name;
        };

        return {
            state,
            selectCurrentPage,
            createIssuesType,
            selectColor
        };
    }
});
</script>
